package ru.ulstu.tsMethods;

import ru.ulstu.models.Forecast;
import ru.ulstu.models.ModelTimeSeries;
import ru.ulstu.models.TimeSeries;

import java.util.HashMap;
import java.util.Map;

public abstract class TimeSeriesMethod {
    protected TimeSeries originalTimeSeries;
    protected ModelTimeSeries model;
    protected Forecast forecast;
    protected int countForecast;
    protected Map<Param, Double> parameters = new HashMap<>();

    protected void init() {
        model = new ModelTimeSeries(originalTimeSeries);
        forecast = new Forecast(originalTimeSeries);
    }

    public TimeSeries getOriginalTimeSeries() {
        return originalTimeSeries;
    }

    public ModelTimeSeries getModel() {
        return model;
    }

    public Forecast getForecast() {
        return forecast;
    }

    public abstract void createModel();
}
